/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */

package org.dive4elements.river.client.client.ui;

import org.dive4elements.river.client.client.artifacthelper.ArtifactHelper;
import org.dive4elements.river.client.shared.model.Data;
import org.dive4elements.river.client.shared.model.DataItem;
import org.dive4elements.river.client.shared.model.DataList;

public class DistanceOnlyPartPanel extends DistanceOnlyPanel {

    private static final long serialVersionUID = -5794138573892656947L;

    public DistanceOnlyPartPanel() {
        super();
    }

    @Override
    protected String getLabel() {
        return this.MSG.distance_part_state();
    }

    @Override
    protected String getLowerField() {
        return "ld_from_part";
    }

    @Override
    protected String getUpperField() {
        return "ld_to_part";
    }

    @Override
    protected void initMinMaxValues(final DataList data) {
        final ArtifactHelper helper = new ArtifactHelper(super.artifact);

        final Data f = helper.getOldDataByKey("ld_from");
        final Data t = helper.getOldDataByKey("ld_to");
        try {
            final DataItem[] fItems = f.getItems();
            final DataItem[] tItems = t.getItems();

            this.min = Double.valueOf(fItems[0].getStringValue());
            this.max = Double.valueOf(tItems[0].getStringValue());
        }
        catch (final NumberFormatException nfe) {
            this.min = -Double.MAX_VALUE;
            this.max = Double.MAX_VALUE;
        }
    }
}
